



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>socket传送文件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">socket传送文件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 01:15:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、文件传送步骤</h2>
<p>　　我们要利用socket来实现下载一个文件，该如何操作呢？</p>
<p>　　服务端：</p>
<ol><li>读取文件名</li>
<li>判断文件是否存在</li>
<li>检测文件大小（用于和客户端对比判断文件是否传送完毕）</li>
<li>发送文件大小给客户端</li>
<li>等待客户端确认（防止粘包）</li>
<li>打开文件</li>
<li>边读边发送数据</li>
<li>md5验证</li></ol>
<p>　　客户端：</p>
<ul><li>发送命令</li>
<li>接收文件大小</li>
<li>返回确认</li>
<li>获取文件名</li>
<li>对比文件大小</li>
<li>写入文件</li></ul>
<h2>二、功能实现（ftp下载功能）</h2>
<p>　　服务端：</p>
<div>
<div>
<pre class="prettyprint linenums"># -*- coding: UTF-8 -*-<br />
import os<br />
import socket

# TCP/IP协议, tcp ,如果不填写就是默认这个<br />
server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

server.bind(('localhost', 9999))

server.listen()

while True:  # 可以接受多个客户端

    conn, addr = server.accept()<br />
    print('new conn', addr)<br />
    while True:

        cmd_res = conn.recv(1024)<br />
        if not cmd_res:   # 防止当接受的客户端数据为空时,程序卡掉<br />
            print('client has lost...')<br />
            break<br />
        else:<br />
            # 获取命令和文件名<br />
            cmd, filename = cmd_res.decode().split()<br />
            print(cmd, filename)<br />
            if os.path.isfile(filename):  # 判断文件是否存在<br />
                # 文件大小<br />
                file_size = os.stat(filename).st_size<br />
                # 发送文件大小<br />
                conn.send(str(file_size).encode(encoding='utf-8'))<br />
                # 等待客户端确认<br />
                conn.recv(1024)<br />
                # 打开文件<br />
                f = open(filename, 'rb')<br />
                for line in f:<br />
                    conn.send(line)<br />
                    print('sending')<br />
                f.close()</pre>
</div>
</div>
<p>　　客户端：</p>
<div>
<div>
<pre class="prettyprint linenums"># -*- coding: UTF-8 -*-<br />
import socket

client = socket.socket()

client.connect(('localhost', 9999))

while True:<br />
    cmd = input('&gt;&gt;:').strip()<br />
    # 判断是否发送空数据,如果是就重新发送<br />
    if len(cmd) == 0:<br />
        continue<br />
    else:<br />
        client.send(cmd.encode('utf-8'))<br />
        # 获取服务端发送的文件大小<br />
        size = client.recv(1024)<br />
        total_file_size = int(size.decode())

        # 返回确认<br />
        client.send(b'file size received')<br />
        filename = cmd.split()[1]<br />
        print(filename)<br />
        received_size = 0<br />
        # 写入文件<br />
        f = open(filename + '.new', 'w', encoding='utf-8')<br />
        while received_size &lt; total_file_size:<br />
            r_data = client.recv(1024)<br />
            received_size += len(r_data)<br />
            f.write(r_data.decode() + '\n')<br />
        else:<br />
            print('file sizes', total_file_size, received_size)<br />
            print('receive finished')<br />
            f.close()</pre>
</div>
</div>
<p>　有些问题 替换一些内容</p>
<pre class="prettyprint linenums">f = open(filename + '.new', 'wb')</pre>
<pre class="prettyprint linenums">f.write(r_data)</pre>
<p>　　　<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/821560/201710/821560-20171029153516539-2079947343.png" /></p>
<p>　　这个程序有缺陷，首先目前只能读取本文件夹下的文件，新生成的文件没有中文乱码问题，ok...</p>
<h2>三、md5验证文件</h2>
<p>　　加个md5来验证文件是否一致</p>
<p>　　服务端：</p>
<div>
<pre class="prettyprint linenums"># -*- coding: UTF-8 -*-<br />
import os<br />
import socket<br />
import hashlib

# TCP/IP协议, tcp ,如果不填写就是默认这个<br />
server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

server.bind(('localhost', 9999))

server.listen()

while True:  # 可以接受多个客户端

    conn, addr = server.accept()<br />
    print('new conn', addr)<br />
    while True:

        cmd_res = conn.recv(1024)<br />
        if not cmd_res:   # 防止当接受的客户端数据为空时,程序卡掉<br />
            print('client has lost...')<br />
            break<br />
        else:<br />
            # md5<br />
            m = hashlib.md5()<br />
            # 获取命令和文件名<br />
            cmd, filename = cmd_res.decode().split()<br />
            print(cmd, filename)<br />
            if os.path.isfile(filename):  # 判断文件是否存在<br />
                # 文件大小<br />
                file_size = os.stat(filename).st_size<br />
                print(file_size)<br />
                # 发送文件大小<br />
                conn.send(str(file_size).encode(encoding='utf-8'))<br />
                # 等待客户端确认<br />
                conn.recv(1024)<br />
                # 打开文件<br />
                f = open(filename, 'rb')<br />
                for line in f:<br />
                    m.update(line)<br />
                    # m.update('abc')  m.update('123')<br />
                    # 其实和m.update('abc123') 结果一下<br />
                    conn.send(line)

                f.close()<br />
                print('send done')<br />
                # 发送md5信息<br />
                conn.send(m.hexdigest().encode('utf-8'))
</pre>
</div>
<p>　　客户端：</p>
<div>
<pre class="prettyprint linenums"># -*- coding: UTF-8 -*-<br />
import socket<br />
import hashlib

client = socket.socket()

client.connect(('localhost', 9999))

while True:<br />
    cmd = input('&gt;&gt;:').strip()<br />
    # 判断是否发送空数据,如果是就重新发送<br />
    if len(cmd) == 0:<br />
        continue<br />
    else:<br />
        client.send(cmd.encode('utf-8'))<br />
        # 获取服务端发送的文件大小<br />
        f_size = client.recv(1024)<br />
        total_file_size = int(f_size.decode())

        # 返回确认<br />
        client.send(b'file size received')<br />
        filename = cmd.split()[1]<br />
        print(filename)<br />
        received_size = 0<br />
        # md5<br />
        m = hashlib.md5()

        # 写入文件<br />
        f = open(filename + '.new', 'wb')  # 新生成的文件也正常显示<br />
        while received_size &lt; total_file_size:<br />
            if total_file_size - received_size &gt; 1024:  # 以此来控制只收文件的内容，不会粘包md5的内容<br />
                size = 1024<br />
            else:<br />
                size = total_file_size - received_size<br />
            r_data = client.recv(size)<br />
            received_size += len(r_data)<br />
            m.update(r_data)<br />
            f.write(r_data)<br />
            # print(r_data.decode())<br />
            # print('file sizes', total_file_size, received_size)<br />
        else:<br />
            print('file sizes', total_file_size, received_size)<br />
            server_md5 = client.recv(1024).decode()<br />
            client_md5 = m.hexdigest()<br />
            print(server_md5)<br />
            print(client_md5)<br />
            print('receive finished')<br />
            f.close()
</pre>
</div>
<p>　　结果：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/821560/201710/821560-20171030190050246-286819403.png" /></p>
<p>　　结果看上去没有问题了，新文件也能生成，并且有内容</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pwojd8.html">简述ASP&period;NET MVC原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z401d9.html">makefile函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7v1j1q.html">java 多线程操作List，已经做了同步synchronized，还会有ConcurrentModificationException，知道为什么吗？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1mnnx8.html">linux centos5&period;7&lpar;32bit&rpar; oracle 10g oracle11g</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0m2pwq.html">j-query    j-query</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xgp39.html">BZOJ 3944 Sum 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z0kn09.html">linux学习方法之一</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x0o3g9.html">ODI性能问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1p1rk9.html">Delphi中methodaddress的汇编代码解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjovlr8.html">asp 操作 xml</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdg40d9.html">在Entity Framework 中用 Code First 创建新的数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg6rkm8.html">Linux 常用命令之二</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zopde3q.html">&lbrack;LeetCode&rsqb; Split Linked List in Parts 拆分链表成部分</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z17639.html">Java语言程序设计-助教篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gx316q.html">浅谈ES6新增数据类型：Symbol</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllozm1q.html">js 获取当前时间 年月日</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvk2d28.html">Spark记录-SparkSql官方文档中文翻译（部分转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjy0l59.html">SpringBoot读取application&period;properties文件内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvyjndq.html">FFT节省资源的思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p7nr5q.html">涉及到【分页】的table的请求模式</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qve43619.html">阿里巴巴将在美国推出电子商务网站11 Main</a>
			</li>
						<li><a href="https://www.batexi.com/a/963v4xn9.html">Android 对话框&lpar;Dialogs&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk0xzv8.html">Thunder-Beta发布中间产物-2017秋-软件工程第十次作业</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pply579.html">Controller控制器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kpnpoq.html">团队Alpha冲刺（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm56e09.html">HDU 5501 The Highest Mark</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvz3gxq.html">CentOS7实现RabbitMQ高可用集群</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnvlr4q.html">cobbler配置要基于PXE 环境，cobbler是pxe环境的二次封装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj175r8.html">bl bl bl bl bl</a>
			</li>
						<li><a href="https://www.batexi.com/a/963vrmn9.html">fsocket发送post实现异步请求</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
